﻿using System;

namespace 匿名类型Demo
{
    class Program
    {
        static void Main(string[] args)
        {
            #region 匿名类型的使用Demo
            // 定义匿名类型
            // 因为这里不知道初始化的类型是什么，所以这里就必须使用隐式类型
            // 此时隐式类型就发挥出了功不可没的作用，从而说明隐式类型的提出是为了服务于匿名类型的
            // 而匿名类型的提出又是服务于Linq，一步步都是在微软团队的计划当中
            Console.WriteLine("进入匿名类型使用演示：");
            var person1 = new { Name = "learning hard", Age = 25 };
            Console.WriteLine("{0} 年龄为: {1}", person1.Name, person1.Age);
            Console.Read();
            Console.WriteLine("按下Enter键进入匿名类型数组演示：");
            Console.WriteLine();
            #endregion

            #region 匿名类型数组演示
            // 定义匿名类型数组
            var personcollection = new[] 
            {
                new {Name ="Tom",Age=30},
                new {Name ="Lily", Age=22},
                new {Name ="Jerry",Age =32},

                // 如果加入下面一句就会出现编译时错误
                // 因为此时编译器就不能推断出要转换为什么类型
                // new {Name ="learning hard"}
            };

            int totalAge = 0;
            foreach (var person in personcollection)
            {
                // 下面代码证明Age属性是强类型的int类型
                totalAge += person.Age;
            }

            Console.WriteLine("所有人的年龄总和为： {0}", totalAge);
            Console.ReadKey();
            #endregion
        }
    }
}
