﻿using System;
using System.Collections.Generic;

namespace 隐式类型Demo
{
    class Program
    {
        static void Main(string[] args)
        { 
            // 用var声明局部变量
            // 不能用一个未赋值的变量来初始化隐私类型
            // 如果变量s被初始化了就可以了
            //string s;
            //var stringvariable = s;

            // 隐式类型的优点
            // 对于复杂类型，减少打字量
            // 使用隐式类型，此时就不需要再赋值的左右两侧都指定Dictionary<string,string>
            var dictionary = new Dictionary<string, string>();
         
            // 在foreach中使用隐式类型
            foreach (var item in dictionary)
            {
                // 
            }

            // 隐式类型的缺点
            // 下面代码使用隐式类型就会使得开发人员很难知道变量的具体类型
            // 所以对于什么情况下使用隐式类型，完全取决个人情况，自己感觉是否使用了隐式类型会使代码看起来更整洁和容易理解
            var a = 2147483649;
            var b = 928888888888;
            var c = 2147483644;
            Console.WriteLine( "变量a的类型为：{0}",a.GetType());
            Console.WriteLine("变量b的类型为：{0}", b.GetType());
            Console.WriteLine("变量c的类型为：{0}", c.GetType());
            Console.Read();

            // 隐式类型数组演示
            // 编译器推断为int[]类型
            var intarray = new[] { 1,2,3,4};

            // 编译器推断为string[] 类型
            var stringarray = new[] { "hello", "learning hard" };

            // 隐式类型数组出错的情况
            //var errorarray = new[] { "hello", 3 };
        }
    }
}
